import { delegateEvents as de, insert as g, createComponent as d, effect as U, setAttribute as ie, template as m, render as $e } from "solid-js/web";
import { createSignal as D, onMount as ue, onCleanup as Me, For as _e, Show as x, createEffect as Se, createContext as De, useContext as ze } from "solid-js";
import { closeBrackets as Ae, autocompletion as Be } from "@codemirror/autocomplete";
import { StateField as Q, RangeSet as T, Compartment as He, EditorState as P, SelectionRange as Ne, EditorSelection as je, RangeSetBuilder as Ee, Transaction as Ve } from "@codemirror/state";
import { vim as Te } from "@replit/codemirror-vim";
import { EditorView as v, Decoration as C, WidgetType as fe, ViewPlugin as Oe, keymap as Ie } from "@codemirror/view";
import { syntaxTree as K, syntaxHighlighting as We, HighlightStyle as Fe } from "@codemirror/language";
import { defaultKeymap as Re, historyKeymap as Ue, indentMore as Pe, indentLess as qe, history as Xe } from "@codemirror/commands";
import { markdown as Qe, markdownLanguage as Ke } from "@codemirror/lang-markdown";
import { languages as Ze } from "@codemirror/language-data";
import { tags as c } from "@lezer/highlight";
const S = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, Ge = (e) => {
  if (Object.prototype.toString.call(e) === S.object)
    return `[object ${e.constructor.name}]`;
}, z = (e, t) => Ge(e) === t, Je = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), r = (o, i) => n.get(o) || (z(o, S.object) && n.set(o, !0), z(i, S.undefined)) ? o : z(o, S.array) && z(i, S.array) ? [...i] : z(o, S.object) && z(i, S.object) ? Object.keys(o).reduce((a, l) => (Object.hasOwn(i, l) ? a[l] = r(o[l], i[l]) : a[l] = o[l], a), {}) : i;
  return r(e, t);
}, N = (e, t) => Je(e, t);
var A = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(A || {}), $ = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))($ || {}), f = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(f || {}), V = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e))(V || {});
const ae = () => document.createElement("div"), pe = () => window.matchMedia("(prefers-color-scheme: dark)").matches, Ye = (e) => e === A.Dark ? !0 : e === A.Light ? !1 : pe(), R = (e) => {
  const t = [
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    { suffix: "modal-position", default: "fixed" },
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], n = !Ye(e.options.interface.appearance);
  return t.map((r) => {
    const o = n && r.light ? r.light : r.default;
    return `--ink-internal-${r.suffix}: var(--ink-${r.suffix}, ${o});`;
  });
}, le = () => [
  v.theme({}, { dark: !0 })
], se = () => [
  v.theme({}, { dark: !1 })
];
class et extends fe {
  constructor() {
    super();
  }
  eq() {
    return !0;
  }
  toDOM() {
    const t = document.createElement("div"), n = t.appendChild(document.createElement("span")), r = t.appendChild(document.createElement("a"));
    return t.setAttribute("aria-hidden", "true"), t.style.bottom = "0", t.style.fontSize = "0.75em", t.style.opacity = "0.5", t.style.position = "absolute", t.style.right = "0", n.innerText = "powered by ", r.href = "https://github.com/voracious/ink-mde", r.innerText = "ink-mde", r.rel = "noopener noreferrer", r.target = "_blank", r.style.color = "var(--ink-internal-color)", r.style.fontWeight = "600", r.style.textDecoration = "none", t;
  }
}
const tt = v.baseTheme({
  ".cm-content": {
    paddingBottom: "2em"
  }
}), nt = Q.define({
  create(e) {
    return T.of(ce().range(e.doc.length));
  },
  update(e, t) {
    return T.of(ce().range(t.newDoc.length));
  },
  provide(e) {
    return v.decorations.from(e);
  }
}), ce = () => C.widget({
  widget: new et(),
  side: 1,
  block: !0
}), ot = () => [
  tt,
  nt
];
class rt extends fe {
  url;
  constructor({ url: t }) {
    super(), this.url = t;
  }
  eq(t) {
    return t.url === this.url;
  }
  toDOM() {
    const t = document.createElement("div"), n = t.appendChild(document.createElement("div")), r = n.appendChild(document.createElement("figure")), o = r.appendChild(document.createElement("img"));
    return t.setAttribute("aria-hidden", "true"), t.className = "cm-image-container", n.className = "cm-image-backdrop", r.className = "cm-image-figure", o.className = "cm-image-img", o.src = this.url, t.style.paddingBottom = "0.5rem", t.style.paddingTop = "0.5rem", n.classList.add("cm-image-backdrop"), n.style.borderRadius = "var(--ink-internal-border-radius)", n.style.display = "flex", n.style.alignItems = "center", n.style.justifyContent = "center", n.style.overflow = "hidden", n.style.maxWidth = "100%", r.style.margin = "0", o.style.display = "block", o.style.maxHeight = "var(--ink-internal-block-max-height)", o.style.maxWidth = "100%", o.style.width = "100%", t;
  }
}
const it = () => {
  const e = /!\[.*?\]\((?<url>.*?)\)/, t = (o) => C.widget({
    widget: new rt(o),
    side: -1,
    block: !0
  }), n = (o) => {
    const i = [];
    return K(o).iterate({
      enter: ({ type: a, from: l, to: s }) => {
        if (a.name === "Image") {
          const u = e.exec(o.doc.sliceString(l, s));
          u && u.groups && u.groups.url && i.push(t({ url: u.groups.url }).range(o.doc.lineAt(l).from));
        }
      }
    }), i.length > 0 ? T.of(i) : C.none;
  };
  return [
    Q.define({
      create(o) {
        return n(o);
      },
      update(o, i) {
        return i.docChanged ? n(i.state) : o.map(i.changes);
      },
      provide(o) {
        return v.decorations.from(o);
      }
    })
  ];
}, at = () => v.contentAttributes.of({
  spellcheck: "true"
}), lt = (e, t) => {
  const n = e.resolver(t);
  return e.compartment.of(n);
}, st = (e) => e.extensions.map((t) => lt(t, e.options)), ct = (e, t) => {
  const n = e.resolver(t);
  return e.compartment.reconfigure(n);
}, me = (e) => e.extensions.map((t) => ct(t, e.options)), _ = (e) => {
  const t = new He(), n = ut[e];
  return {
    compartment: t,
    name: e,
    resolver: n
  };
}, dt = () => [
  _($.Appearance),
  _($.Attribution),
  _($.Autocomplete),
  _($.Images),
  _($.ReadOnly),
  _($.Spellcheck),
  _($.Vim)
], ut = {
  appearance({ interface: { appearance: e } }) {
    return e === A.Dark ? le() : e === A.Light ? se() : pe() ? le() : se();
  },
  attribution(e) {
    return e.interface.attribution ? ot() : [];
  },
  autocomplete(e) {
    return e.interface.autocomplete ? Ae() : [];
  },
  images(e) {
    return e.interface.images ? it() : [];
  },
  readonly(e) {
    return e.interface.readonly ? P.readOnly.of(!0) : P.readOnly.of(!1);
  },
  spellcheck(e) {
    return e.interface.spellcheck ? at() : [];
  },
  vim(e) {
    return e.vim ? Te() : [];
  }
}, q = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: A.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    plugins: [],
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    editor: {},
    extensions: dt(),
    options: e,
    root: ae(),
    target: ae()
  };
}, ft = (e) => N(q(), e), ge = (e) => {
  const [t, n] = D(ft({ options: e }));
  return [t, n];
}, he = (e) => {
  const t = e.map((n) => Ne.fromJSON({ anchor: n.start, head: n.end }));
  return je.create(t);
}, pt = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), w = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), mt = {
  [f.Bold]: w({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [f.Code]: w({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [f.CodeBlock]: w({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [f.Heading]: w({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [f.Image]: w({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [f.Italic]: w({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [f.Link]: w({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [f.OrderedList]: w({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [f.Quote]: w({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [f.TaskList]: w({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [f.List]: w({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, ke = ([e, t], n) => {
  const { editor: r } = e(), o = r.lineBlockAt(n.start), i = r.lineBlockAt(n.end);
  return { start: o.from, end: i.to };
}, gt = ([e, t], n) => {
  const { editor: r } = e();
  let o = n.start;
  const i = [];
  for (; o <= n.end; ) {
    const a = r.lineBlockAt(o), l = Math.max(o, a.from), s = Math.min(o, a.to);
    i.push({ start: l, end: s }), o = a.to + 1;
  }
  return i;
}, ht = ([e, t], n) => {
  const { editor: r } = e(), o = r.state.wordAt(n.start)?.from || n.start, i = r.state.wordAt(n.end)?.to || n.end;
  return { start: o, end: i };
}, kt = ([e, t], n) => n || O([e, t]).pop() || { start: 0, end: 0 }, xe = ([e, t], n) => {
  const { editor: r } = e();
  return r.state.sliceDoc(n.start, n.end);
}, Z = ([e, t], n, r) => xt(e(), r).find(({ type: i }) => n.nodes.includes(i.name)), xt = ({ editor: { state: e } }, t) => {
  const n = [];
  return K(e).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: r, from: o, to: i }) => {
      n.push({ type: r, from: o, to: i });
    }
  }), n;
}, G = ([e, t], n, r) => {
  const o = xe([e, t], r), i = n.prefix.length, a = n.suffix.length * -1 || o.length, l = o.slice(i, a);
  B([e, t], l, r);
}, bt = ([e, t], n, r) => {
  const o = ke([e, t], r), i = Z([e, t], n, o);
  if (i) {
    const a = i.from, l = i.to;
    G([e, t], n, { start: a, end: l });
  } else {
    const a = n.prefix, l = n.suffix;
    I([e, t], { before: a, after: l, selection: o });
  }
}, vt = ([e, t], n, r) => {
  gt([e, t], r).forEach((i) => {
    be([e, t], n, i);
  });
}, be = ([e, t], n, r) => {
  const o = ke([e, t], r), i = Z([e, t], n, o), a = n.prefixStates.length > 0;
  if (i && a)
    n.prefixStates.find((l, s) => {
      const u = i.from, h = i.to, y = xe([e, t], { start: u, end: h }), L = y.startsWith(l);
      return L && B([e, t], y.replace(new RegExp(`^${l}`), n.prefixStates[s + 1]), { start: u, end: h }), L;
    });
  else if (i) {
    const l = i.from, s = i.to;
    G([e, t], n, { start: l, end: s });
  } else {
    const l = n.prefix, s = n.suffix;
    I([e, t], { before: l, after: s, selection: o });
  }
}, yt = ([e, t], n, r) => {
  const o = Z([e, t], n, r);
  if (o) {
    const i = o.from, a = o.to;
    G([e, t], n, { start: i, end: a });
  } else {
    const { start: i, end: a } = ht([e, t], r), l = Array.isArray(n.prefix) ? n.prefix[0] : n.prefix, s = n.suffix;
    I([e, t], { before: l, after: s, selection: { start: i, end: a } });
  }
}, wt = ([e, t], n, r) => {
  const o = mt[n], i = kt([e, t], r);
  o.block ? bt([e, t], o, i) : o.multiline ? vt([e, t], o, i) : o.line ? be([e, t], o, i) : yt([e, t], o, i);
}, Ct = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], Lt = C.line({ attributes: { class: "cm-codeblock" } }), $t = C.line({ attributes: { class: "cm-codeblock-open" } }), Mt = C.line({ attributes: { class: "cm-codeblock-close" } }), _t = C.mark({ attributes: { class: "cm-code" } }), St = C.mark({ attributes: { class: "cm-code cm-code-open" } }), Dt = C.mark({ attributes: { class: "cm-code cm-code-close" } }), zt = Oe.define((e) => ({
  update: () => At(e)
}), { decorations: (e) => e.update() }), At = (e) => {
  const t = new Ee(), n = K(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      let a;
      n.iterate({
        enter({ type: l, from: s, to: u }) {
          if (l.name !== "Document")
            if (Ct.includes(l.name)) {
              t.add(i.from, i.from, Lt);
              const h = e.state.doc.lineAt(s), y = e.state.doc.lineAt(u);
              return h.number === i.number && t.add(i.from, i.from, $t), y.number === i.number && t.add(i.from, i.from, Mt), !1;
            } else
              l.name === "InlineCode" ? a = { from: s, to: u, innerFrom: s, innerTo: u } : l.name === "CodeMark" && (s === a.from ? (a.innerFrom = u, t.add(s, u, St)) : u === a.to && (a.innerTo = s, t.add(a.innerFrom, a.innerTo, _t), t.add(s, u, Dt)));
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, Bt = () => [
  zt
], Ht = () => [
  v.editorAttributes.of({
    class: "ink-mde-editor"
  }),
  v.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
], Nt = () => [
  ...Ht()
], jt = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? Pe({ state: e, dispatch: t }) : (t(e.update(e.replaceSelection("  "), {
      scrollIntoView: !0,
      annotations: Ve.userEvent.of("input")
    })), !0),
    shift: qe
  }
], Et = () => Ie.of([
  ...jt,
  ...Re,
  ...Ue
]), Vt = () => v.lineWrapping, Tt = () => [
  We(Fe.define([
    {
      tag: c.atom,
      color: "var(--ink-internal-syntax-atom-color)"
    },
    {
      tag: c.meta,
      color: "var(--ink-internal-syntax-meta-color)"
    },
    {
      tag: c.emphasis,
      color: "var(--ink-internal-syntax-emphasis-color)",
      fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
    },
    {
      tag: c.strong,
      color: "var(--ink-internal-syntax-strong-color)",
      fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
    },
    {
      tag: c.strikethrough,
      color: "var(--ink-internal-syntax-strikethrough-color)",
      textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
    },
    {
      tag: c.comment,
      color: "var(--ink-internal-syntax-comment-color)",
      fontStyle: "var(--ink-internal-syntax-comment-font-style)"
    },
    {
      tag: c.monospace,
      color: "var(--ink-internal-syntax-code-color)",
      fontFamily: "var(--ink-internal-syntax-code-font-family)"
    },
    {
      tag: c.name,
      color: "var(--ink-internal-syntax-name-color)"
    },
    {
      tag: c.labelName,
      color: "var(--ink-internal-syntax-name-label-color)"
    },
    {
      tag: c.propertyName,
      color: "var(--ink-internal-syntax-name-property-color)"
    },
    {
      tag: c.definition(c.propertyName),
      color: "var(--ink-internal-syntax-name-property-definition-color)"
    },
    {
      tag: c.variableName,
      color: "var(--ink-internal-syntax-name-variable-color)"
    },
    {
      tag: c.definition(c.variableName),
      color: "var(--ink-internal-syntax-name-variable-definition-color)"
    },
    {
      tag: c.local(c.variableName),
      color: "var(--ink-internal-syntax-name-variable-local-color)"
    },
    {
      tag: c.special(c.variableName),
      color: "var(--ink-internal-syntax-name-variable-special-color)"
    },
    {
      tag: c.heading,
      color: "var(--ink-internal-syntax-heading-color)",
      fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
    },
    {
      tag: c.heading1,
      color: "var(--ink-internal-syntax-heading1-color)",
      fontSize: "var(--ink-internal-syntax-heading1-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
    },
    {
      tag: c.heading2,
      color: "var(--ink-internal-syntax-heading2-color)",
      fontSize: "var(--ink-internal-syntax-heading2-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
    },
    {
      tag: c.heading3,
      color: "var(--ink-internal-syntax-heading3-color)",
      fontSize: "var(--ink-internal-syntax-heading3-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
    },
    {
      tag: c.heading4,
      color: "var(--ink-internal-syntax-heading4-color)",
      fontSize: "var(--ink-internal-syntax-heading4-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
    },
    {
      tag: c.heading5,
      color: "var(--ink-internal-syntax-heading5-color)",
      fontSize: "var(--ink-internal-syntax-heading5-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
    },
    {
      tag: c.heading6,
      color: "var(--ink-internal-syntax-heading6-color)",
      fontSize: "var(--ink-internal-syntax-heading6-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
    },
    {
      tag: c.keyword,
      color: "var(--ink-internal-syntax-keyword-color)"
    },
    {
      tag: c.number,
      color: "var(--ink-internal-syntax-number-color)"
    },
    {
      tag: c.operator,
      color: "var(--ink-internal-syntax-operator-color)"
    },
    {
      tag: c.punctuation,
      color: "var(--ink-internal-syntax-punctuation-color)"
    },
    {
      tag: c.link,
      color: "var(--ink-internal-syntax-link-color)"
    },
    {
      tag: c.url,
      color: "var(--ink-internal-syntax-url-color)"
    },
    {
      tag: c.string,
      color: "var(--ink-internal-syntax-string-color)"
    },
    {
      tag: c.special(c.string),
      color: "var(--ink-internal-syntax-string-special-color)"
    },
    {
      tag: c.processingInstruction,
      color: "var(--ink-internal-syntax-processing-instruction-color)"
    }
  ]))
], Ot = (e) => {
  if (e.length > 0)
    return he(e);
}, ve = (e) => {
  const t = e.options.plugins.flatMap((o) => o.type === V.Completion ? o.value : []), n = e.options.plugins.flatMap((o) => o.type === V.Default ? o.value : []), r = e.options.plugins.flatMap((o) => o.type === V.Grammar ? o.value : []);
  return P.create({
    doc: e.options.doc,
    selection: Ot(e.options.selections),
    extensions: [
      ...st(e),
      Be({
        defaultKeymap: !0,
        icons: !1,
        override: t,
        optionClass: () => "ink-tooltip-option"
      }),
      Bt(),
      Xe(),
      Nt(),
      Et(),
      Vt(),
      Qe({
        base: Ke,
        codeLanguages: Ze,
        extensions: r
      }),
      Tt(),
      ...n
    ]
  });
}, It = ([e, t]) => {
  const { editor: n } = e();
  n.destroy();
}, Wt = ([e, t]) => {
  const { editor: n } = e();
  return n.state.sliceDoc();
}, X = ([e, t]) => {
  const { editor: n } = e();
  n.hasFocus || n.focus();
}, Ft = ([e, t], n, r) => wt([e, t], n, r), B = ([e, t], n, r, o = !1) => {
  const { editor: i } = e();
  let a = r?.start, l = r?.end || r?.start;
  if (typeof a > "u") {
    const u = O([e, t]).pop();
    a = u.start, l = u.end;
  }
  const s = { changes: { from: a, to: l, insert: n } };
  if (o) {
    const u = a === l ? a + n.length : a, h = a + n.length;
    Object.assign(s, { selection: { anchor: u, head: h } });
  }
  i.dispatch(i.state.update(s));
}, Rt = ([e, t], n) => {
  t(N(e(), { options: { doc: n } })), e().editor.setState(ve(e()));
}, Ut = (e) => ({
  destroy: It.bind(void 0, e),
  doc: Wt.bind(void 0, e),
  focus: X.bind(void 0, e),
  insert: B.bind(void 0, e),
  load: Rt.bind(void 0, e),
  options: Pt.bind(void 0, e),
  reconfigure: qt.bind(void 0, e),
  select: ye.bind(void 0, e),
  selections: O.bind(void 0, e),
  update: Xt.bind(void 0, e),
  wrap: I.bind(void 0, e)
}), Pt = ([e]) => e().options, qt = ([e, t], n) => {
  const r = me(t(N(e(), { options: n })));
  e().editor.dispatch({
    effects: r
  });
}, ye = ([e, t], n) => {
  const { editor: r } = e();
  r.dispatch(r.state.update({
    selection: he(n)
  }));
}, O = ([e, t]) => {
  const { editor: n } = e();
  return pt(n.state.selection);
}, Xt = ([e, t], n) => {
  const { editor: r } = e();
  r.dispatch(r.state.update({
    changes: {
      from: 0,
      to: r.state.doc.length,
      insert: n
    }
  }));
}, I = ([e, t], { after: n, before: r, selection: o }) => {
  const { editor: i } = e(), a = o || O([e, t]).pop() || { start: 0, end: 0 }, l = i.state.sliceDoc(a.start, a.end);
  B([e, t], `${r}${l}${n}`, a), ye([e, t], [{ start: a.start + r.length, end: a.end + r.length }]);
}, Qt = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, Kt = /* @__PURE__ */ m("<span>uploading files...</span>", 2), Zt = /* @__PURE__ */ m('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 16), Gt = /* @__PURE__ */ m('<img class="ink-drop-zone-file-preview-image">', 1), Jt = /* @__PURE__ */ m("<span>drop files here</span>", 2), Yt = () => {
  const [e, t] = D(0), [n, r] = D([]), [o, i] = D(!1), [a, l] = D(!1), [s, u] = j(), h = () => {
    l(!1);
  }, y = (p) => {
    if (s().options.files.dragAndDrop) {
      p.preventDefault(), p.stopPropagation();
      const k = p.dataTransfer;
      k?.files ? te(k.files) : (t(0), l(!1), r([]));
    }
  }, L = (p) => {
    s().options.files.dragAndDrop && (p.preventDefault(), t(e() + 1), l(!0));
  }, M = (p) => {
    s().options.files.dragAndDrop && (p.preventDefault(), t(e() - 1), e() === 0 && l(!1));
  }, J = (p) => {
    s().options.files.dragAndDrop && (p.preventDefault(), l(!0));
  }, Y = (p) => {
    s().options.files.dragAndDrop && (p.preventDefault(), t(0), l(!1));
  }, ee = (p) => {
    if (s().options.files.clipboard) {
      p.preventDefault();
      const k = p.clipboardData;
      k?.files && k.files.length > 0 && te(k.files);
    }
  }, te = (p) => {
    Array.from(p).forEach((k) => {
      r([...n(), k]);
    }), i(!0), l(!0), Promise.resolve(s().options.files.handler(p)).then((k) => {
      if (s().options.files.injectMarkup && k) {
        const W = `![](${k})`;
        B([s, u], W);
      }
    }).finally(() => {
      t(0), i(!1), l(!1), r([]);
    });
  };
  return ue(() => {
    document.addEventListener("dragenter", L), document.addEventListener("dragleave", M), document.addEventListener("dragover", J), document.addEventListener("drop", Y), s().root.addEventListener("paste", ee);
  }), Me(() => {
    document.removeEventListener("dragenter", L), document.removeEventListener("dragleave", M), document.removeEventListener("dragover", J), document.removeEventListener("drop", Y), s().root.removeEventListener("paste", ee);
  }), (() => {
    const p = Zt.cloneNode(!0), k = p.firstChild, W = k.nextSibling, E = W.firstChild, Ce = E.firstChild, Le = E.nextSibling;
    return k.textContent = Qt, E.addEventListener("drop", y), g(Ce, d(_e, {
      get each() {
        return n().slice(0, 8);
      },
      children: (ne) => (() => {
        const F = Gt.cloneNode(!0);
        return U((H) => {
          const oe = ne.name, re = URL.createObjectURL(ne);
          return oe !== H._v$ && ie(F, "alt", H._v$ = oe), re !== H._v$2 && ie(F, "src", H._v$2 = re), H;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), F;
      })()
    })), g(E, d(x, {
      get when() {
        return o();
      },
      get fallback() {
        return Jt.cloneNode(!0);
      },
      get children() {
        return Kt.cloneNode(!0);
      }
    }), null), Le.$$click = h, U(() => p.classList.toggle("visible", !!a())), p;
  })();
};
de(["click"]);
const en = (e) => {
  const t = new v({
    dispatch: (n) => {
      const { options: r } = e;
      r.hooks.beforeUpdate(n.newDoc.toString()), t.update([n]), n.docChanged && r.hooks.afterUpdate(n.newDoc.toString());
    },
    state: ve(e)
  });
  return t;
}, tn = () => {
  const [e, t] = j(), n = en(e());
  return t(N(e(), {
    editor: n
  })), n.dom;
}, nn = /* @__PURE__ */ m('<button class="ink-button"></button>', 2), b = (e) => (() => {
  const t = nn.cloneNode(!0);
  return t.$$click = (n) => e.onclick(n), g(t, () => e.children), t;
})();
de(["click"]);
const on = `.ink .ink-toolbar{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);bottom:.25rem;color:inherit;display:flex;flex-shrink:0;gap:2rem;overflow:auto;padding:.25rem;position:sticky;top:.25rem;z-index:10}.ink .ink-toolbar-group{display:flex}.ink .ink-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink .ink-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink .ink-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, rn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), an = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), ln = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), sn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), cn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), dn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), un = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), fn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), pn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), mn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), gn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), hn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), kn = /* @__PURE__ */ m('<input type="file">', 1), xn = /* @__PURE__ */ m('<div class="ink-toolbar"><style></style><div class="ink-toolbar-group"></div><div class="ink-toolbar-group"></div><div class="ink-toolbar-group"></div><div class="ink-toolbar-group"></div></div>', 12), bn = () => {
  const [e, t] = j(), [n, r] = D(), o = (l) => {
    Ft([e, t], l), X([e, t]);
  }, i = (l) => {
    const s = l.target;
    s?.files && Promise.resolve(e().options.files.handler(s.files)).then((u) => {
      const h = `![](${u})`;
      B([e, t], h), X([e, t]);
    });
  }, a = () => {
    n()?.click();
  };
  return (() => {
    const l = xn.cloneNode(!0), s = l.firstChild, u = s.nextSibling, h = u.nextSibling, y = h.nextSibling, L = y.nextSibling;
    return s.textContent = on, g(u, d(x, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Heading),
          get children() {
            return rn.cloneNode(!0);
          }
        });
      }
    }), null), g(u, d(x, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Bold),
          get children() {
            return an.cloneNode(!0);
          }
        });
      }
    }), null), g(u, d(x, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Italic),
          get children() {
            return ln.cloneNode(!0);
          }
        });
      }
    }), null), g(h, d(x, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Quote),
          get children() {
            return sn.cloneNode(!0);
          }
        });
      }
    }), null), g(h, d(x, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.CodeBlock),
          get children() {
            return cn.cloneNode(!0);
          }
        });
      }
    }), null), g(h, d(x, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Code),
          get children() {
            return dn.cloneNode(!0);
          }
        });
      }
    }), null), g(y, d(x, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.List),
          get children() {
            return un.cloneNode(!0);
          }
        });
      }
    }), null), g(y, d(x, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.OrderedList),
          get children() {
            return fn.cloneNode(!0);
          }
        });
      }
    }), null), g(y, d(x, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.TaskList),
          get children() {
            return pn.cloneNode(!0);
          }
        });
      }
    }), null), g(L, d(x, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Link),
          get children() {
            return mn.cloneNode(!0);
          }
        });
      }
    }), null), g(L, d(x, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return d(b, {
          onclick: () => o(f.Image),
          get children() {
            return gn.cloneNode(!0);
          }
        });
      }
    }), null), g(L, d(x, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return d(b, {
          onclick: a,
          get children() {
            return [hn.cloneNode(!0), (() => {
              const M = kn.cloneNode(!0);
              return r(M), M.addEventListener("change", i), M.style.setProperty("display", "none"), M;
            })()];
          }
        });
      }
    }), null), l;
  })();
}, vn = `.ink{color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);gap:1rem;padding:var(--ink-internal-editor-padding, 0)}.ink .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, yn = /* @__PURE__ */ m("<style> </style>", 2), wn = () => {
  const [e] = j(), [t, n] = D(R(e()));
  return Se(() => {
    n(R(e()));
  }), ue(() => {
    const r = window.matchMedia("(prefers-color-scheme: dark)"), o = (i) => {
      const {
        editor: a,
        root: l
      } = e();
      if (l.isConnected) {
        const s = me(e());
        a.dispatch({
          effects: s
        }), n(R(e()));
      } else
        r.removeEventListener("change", o);
    };
    r.addEventListener("change", o);
  }), (() => {
    const r = yn.cloneNode(!0), o = r.firstChild;
    return U(() => o.data = `.ink {
  ${t().join(`
  `)}
}
${vn}`), r;
  })();
}, Cn = /* @__PURE__ */ m('<div class="ink ink-mde"></div>', 2), Ln = () => {
  const [e, t] = j(), n = (r) => {
    t(N(e(), {
      root: r
    }));
  };
  return (() => {
    const r = Cn.cloneNode(!0);
    return n(r), g(r, d(wn, {}), null), g(r, d(Yt, {}), null), g(r, d(x, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return d(bn, {});
      }
    }), null), g(r, d(tn, {}), null), r;
  })();
}, we = De([() => q(), (e) => typeof e == "function" ? e(q()) : e]), $n = (e) => d(we.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), j = () => ze(we), Mn = (e) => d($n, {
  get store() {
    return e.store;
  },
  get children() {
    return d(Ln, {
      get store() {
        return e.store;
      }
    });
  }
}), Tn = ({ theme: e, decorator: t }) => {
  const n = v.baseTheme(e), r = (a) => C.widget({
    widget: a,
    side: -1,
    block: !0
  }), o = (a) => {
    const s = t(a).map((u) => r(u.widget).range(u.from, u.to));
    return s.length > 0 ? T.of(s) : C.none;
  }, i = Q.define({
    create(a) {
      return o(a);
    },
    update(a, l) {
      return l.docChanged ? o(l.state) : a.map(l.changes);
    },
    provide(a) {
      return v.decorations.from(a);
    }
  });
  return [
    n,
    i
  ];
}, On = (e = {}) => (ge(e), ""), In = (e) => e, Wn = (e, t = {}) => {
  const n = ge(t);
  return $e(() => d(Mn, {
    store: n
  }), e), Ut(n);
};
export {
  A as Appearance,
  $ as Extensions,
  f as Markup,
  V as PluginType,
  Wn as default,
  In as defineOptions,
  Tn as extension,
  Wn as ink,
  On as ssr
};
