import { delegateEvents as $e, getNextElement as p, getNextMarker as x, insert as k, createComponent as u, effect as ae, setAttribute as ke, runHydrationEvents as we, template as m, hydrate as Ke } from "solid-js/web";
import { createSignal as B, onMount as _e, onCleanup as Ze, For as Ge, Show as v, createEffect as Ye, createContext as Je, useContext as et } from "solid-js";
import { closeBrackets as tt, autocompletion as nt } from "@codemirror/autocomplete";
import { StateField as de, RangeSet as J, Compartment as ot, EditorState as le, SelectionRange as rt, EditorSelection as it, RangeSetBuilder as at, Transaction as lt } from "@codemirror/state";
import { vim as st } from "@replit/codemirror-vim";
import { EditorView as w, Decoration as L, WidgetType as Ce, ViewPlugin as ct, keymap as dt } from "@codemirror/view";
import { syntaxTree as ue, syntaxHighlighting as ut, HighlightStyle as ft } from "@codemirror/language";
import { defaultKeymap as gt, historyKeymap as pt, indentMore as mt, indentLess as ht, history as kt } from "@codemirror/commands";
import { markdown as xt, markdownLanguage as bt } from "@codemirror/lang-markdown";
import { languages as vt } from "@codemirror/language-data";
import { tags as d } from "@lezer/highlight";
const H = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, yt = (e) => {
  if (Object.prototype.toString.call(e) === H.object)
    return `[object ${e.constructor.name}]`;
}, V = (e, n) => yt(e) === n, $t = (e, n) => {
  const t = /* @__PURE__ */ new WeakMap(), o = (r, i) => t.get(r) || (V(r, H.object) && t.set(r, !0), V(i, H.undefined)) ? r : V(r, H.array) && V(i, H.array) ? [...i] : V(r, H.object) && V(i, H.object) ? Object.keys(r).reduce((a, l) => (Object.hasOwn(i, l) ? a[l] = o(r[l], i[l]) : a[l] = r[l], a), {}) : i;
  return o(e, n);
}, F = (e, n) => $t(e, n);
var T = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(T || {}), M = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(M || {}), g = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(g || {}), Y = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e))(Y || {});
const xe = () => document.createElement("div"), Le = () => window.matchMedia("(prefers-color-scheme: dark)").matches, wt = (e) => e === T.Dark ? !0 : e === T.Light ? !1 : Le(), ie = (e) => {
  const n = [
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    { suffix: "modal-position", default: "fixed" },
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], t = !wt(e.options.interface.appearance);
  return n.map((o) => {
    const r = t && o.light ? o.light : o.default;
    return `--ink-internal-${o.suffix}: var(--ink-${o.suffix}, ${r});`;
  });
}, be = () => [
  w.theme({}, { dark: !0 })
], ve = () => [
  w.theme({}, { dark: !1 })
];
class _t extends Ce {
  constructor() {
    super();
  }
  eq() {
    return !0;
  }
  toDOM() {
    const n = document.createElement("div"), t = n.appendChild(document.createElement("span")), o = n.appendChild(document.createElement("a"));
    return n.setAttribute("aria-hidden", "true"), n.style.bottom = "0", n.style.fontSize = "0.75em", n.style.opacity = "0.5", n.style.position = "absolute", n.style.right = "0", t.innerText = "powered by ", o.href = "https://github.com/voracious/ink-mde", o.innerText = "ink-mde", o.rel = "noopener noreferrer", o.target = "_blank", o.style.color = "var(--ink-internal-color)", o.style.fontWeight = "600", o.style.textDecoration = "none", n;
  }
}
const Ct = w.baseTheme({
  ".cm-content": {
    paddingBottom: "2em"
  }
}), Lt = de.define({
  create(e) {
    return J.of(ye().range(e.doc.length));
  },
  update(e, n) {
    return J.of(ye().range(n.newDoc.length));
  },
  provide(e) {
    return w.decorations.from(e);
  }
}), ye = () => L.widget({
  widget: new _t(),
  side: 1,
  block: !0
}), St = () => [
  Ct,
  Lt
];
class Mt extends Ce {
  url;
  constructor({ url: n }) {
    super(), this.url = n;
  }
  eq(n) {
    return n.url === this.url;
  }
  toDOM() {
    const n = document.createElement("div"), t = n.appendChild(document.createElement("div")), o = t.appendChild(document.createElement("figure")), r = o.appendChild(document.createElement("img"));
    return n.setAttribute("aria-hidden", "true"), n.className = "cm-image-container", t.className = "cm-image-backdrop", o.className = "cm-image-figure", r.className = "cm-image-img", r.src = this.url, n.style.paddingBottom = "0.5rem", n.style.paddingTop = "0.5rem", t.classList.add("cm-image-backdrop"), t.style.borderRadius = "var(--ink-internal-border-radius)", t.style.display = "flex", t.style.alignItems = "center", t.style.justifyContent = "center", t.style.overflow = "hidden", t.style.maxWidth = "100%", o.style.margin = "0", r.style.display = "block", r.style.maxHeight = "var(--ink-internal-block-max-height)", r.style.maxWidth = "100%", r.style.width = "100%", n;
  }
}
const At = () => {
  const e = /!\[.*?\]\((?<url>.*?)\)/, n = (r) => L.widget({
    widget: new Mt(r),
    side: -1,
    block: !0
  }), t = (r) => {
    const i = [];
    return ue(r).iterate({
      enter: ({ type: a, from: l, to: s }) => {
        if (a.name === "Image") {
          const c = e.exec(r.doc.sliceString(l, s));
          c && c.groups && c.groups.url && i.push(n({ url: c.groups.url }).range(r.doc.lineAt(l).from));
        }
      }
    }), i.length > 0 ? J.of(i) : L.none;
  };
  return [
    de.define({
      create(r) {
        return t(r);
      },
      update(r, i) {
        return i.docChanged ? t(i.state) : r.map(i.changes);
      },
      provide(r) {
        return w.decorations.from(r);
      }
    })
  ];
}, Dt = () => w.contentAttributes.of({
  spellcheck: "true"
}), zt = (e, n) => {
  const t = e.resolver(n);
  return e.compartment.of(t);
}, Ht = (e) => e.extensions.map((n) => zt(n, e.options)), Bt = (e, n) => {
  const t = e.resolver(n);
  return e.compartment.reconfigure(t);
}, Se = (e) => e.extensions.map((n) => Bt(n, e.options)), z = (e) => {
  const n = new ot(), t = jt[e];
  return {
    compartment: n,
    name: e,
    resolver: t
  };
}, Et = () => [
  z(M.Appearance),
  z(M.Attribution),
  z(M.Autocomplete),
  z(M.Images),
  z(M.ReadOnly),
  z(M.Spellcheck),
  z(M.Vim)
], jt = {
  appearance({ interface: { appearance: e } }) {
    return e === T.Dark ? be() : e === T.Light ? ve() : Le() ? be() : ve();
  },
  attribution(e) {
    return e.interface.attribution ? St() : [];
  },
  autocomplete(e) {
    return e.interface.autocomplete ? tt() : [];
  },
  images(e) {
    return e.interface.images ? At() : [];
  },
  readonly(e) {
    return e.interface.readonly ? le.readOnly.of(!0) : le.readOnly.of(!1);
  },
  spellcheck(e) {
    return e.interface.spellcheck ? Dt() : [];
  },
  vim(e) {
    return e.vim ? st() : [];
  }
}, se = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: T.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    plugins: [],
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    editor: {},
    extensions: Et(),
    options: e,
    root: xe(),
    target: xe()
  };
}, Vt = (e) => F(se(), e), Me = (e) => {
  const [n, t] = B(Vt({ options: e }));
  return [n, t];
}, Ae = (e) => {
  const n = e.map((t) => rt.fromJSON({ anchor: t.start, head: t.end }));
  return it.create(n);
}, Tt = (e) => e.ranges.map((t) => ({
  end: t.anchor < t.head ? t.head : t.anchor,
  start: t.head < t.anchor ? t.head : t.anchor
})), C = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), Nt = {
  [g.Bold]: C({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [g.Code]: C({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [g.CodeBlock]: C({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [g.Heading]: C({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [g.Image]: C({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [g.Italic]: C({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [g.Link]: C({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [g.OrderedList]: C({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [g.Quote]: C({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [g.TaskList]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [g.List]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, De = ([e, n], t) => {
  const { editor: o } = e(), r = o.lineBlockAt(t.start), i = o.lineBlockAt(t.end);
  return { start: r.from, end: i.to };
}, Ot = ([e, n], t) => {
  const { editor: o } = e();
  let r = t.start;
  const i = [];
  for (; r <= t.end; ) {
    const a = o.lineBlockAt(r), l = Math.max(r, a.from), s = Math.min(r, a.to);
    i.push({ start: l, end: s }), r = a.to + 1;
  }
  return i;
}, It = ([e, n], t) => {
  const { editor: o } = e(), r = o.state.wordAt(t.start)?.from || t.start, i = o.state.wordAt(t.end)?.to || t.end;
  return { start: r, end: i };
}, Wt = ([e, n], t) => t || ee([e, n]).pop() || { start: 0, end: 0 }, ze = ([e, n], t) => {
  const { editor: o } = e();
  return o.state.sliceDoc(t.start, t.end);
}, fe = ([e, n], t, o) => Ft(e(), o).find(({ type: i }) => t.nodes.includes(i.name)), Ft = ({ editor: { state: e } }, n) => {
  const t = [];
  return ue(e).iterate({
    from: n.start,
    to: n.end,
    enter: ({ type: o, from: r, to: i }) => {
      t.push({ type: o, from: r, to: i });
    }
  }), t;
}, ge = ([e, n], t, o) => {
  const r = ze([e, n], o), i = t.prefix.length, a = t.suffix.length * -1 || r.length, l = r.slice(i, a);
  N([e, n], l, o);
}, Rt = ([e, n], t, o) => {
  const r = De([e, n], o), i = fe([e, n], t, r);
  if (i) {
    const a = i.from, l = i.to;
    ge([e, n], t, { start: a, end: l });
  } else {
    const a = t.prefix, l = t.suffix;
    te([e, n], { before: a, after: l, selection: r });
  }
}, Pt = ([e, n], t, o) => {
  Ot([e, n], o).forEach((i) => {
    He([e, n], t, i);
  });
}, He = ([e, n], t, o) => {
  const r = De([e, n], o), i = fe([e, n], t, r), a = t.prefixStates.length > 0;
  if (i && a)
    t.prefixStates.find((l, s) => {
      const c = i.from, b = i.to, y = ze([e, n], { start: c, end: b }), S = y.startsWith(l);
      return S && N([e, n], y.replace(new RegExp(`^${l}`), t.prefixStates[s + 1]), { start: c, end: b }), S;
    });
  else if (i) {
    const l = i.from, s = i.to;
    ge([e, n], t, { start: l, end: s });
  } else {
    const l = t.prefix, s = t.suffix;
    te([e, n], { before: l, after: s, selection: r });
  }
}, Ut = ([e, n], t, o) => {
  const r = fe([e, n], t, o);
  if (r) {
    const i = r.from, a = r.to;
    ge([e, n], t, { start: i, end: a });
  } else {
    const { start: i, end: a } = It([e, n], o), l = Array.isArray(t.prefix) ? t.prefix[0] : t.prefix, s = t.suffix;
    te([e, n], { before: l, after: s, selection: { start: i, end: a } });
  }
}, qt = ([e, n], t, o) => {
  const r = Nt[t], i = Wt([e, n], o);
  r.block ? Rt([e, n], r, i) : r.multiline ? Pt([e, n], r, i) : r.line ? He([e, n], r, i) : Ut([e, n], r, i);
}, Xt = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], Qt = L.line({ attributes: { class: "cm-codeblock" } }), Kt = L.line({ attributes: { class: "cm-codeblock-open" } }), Zt = L.line({ attributes: { class: "cm-codeblock-close" } }), Gt = L.mark({ attributes: { class: "cm-code" } }), Yt = L.mark({ attributes: { class: "cm-code cm-code-open" } }), Jt = L.mark({ attributes: { class: "cm-code cm-code-close" } }), en = ct.define((e) => ({
  update: () => tn(e)
}), { decorations: (e) => e.update() }), tn = (e) => {
  const n = new at(), t = ue(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      let a;
      t.iterate({
        enter({ type: l, from: s, to: c }) {
          if (l.name !== "Document")
            if (Xt.includes(l.name)) {
              n.add(i.from, i.from, Qt);
              const b = e.state.doc.lineAt(s), y = e.state.doc.lineAt(c);
              return b.number === i.number && n.add(i.from, i.from, Kt), y.number === i.number && n.add(i.from, i.from, Zt), !1;
            } else
              l.name === "InlineCode" ? a = { from: s, to: c, innerFrom: s, innerTo: c } : l.name === "CodeMark" && (s === a.from ? (a.innerFrom = c, n.add(s, c, Yt)) : c === a.to && (a.innerTo = s, n.add(a.innerFrom, a.innerTo, Gt), n.add(s, c, Jt)));
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return n.finish();
}, nn = () => [
  en
], on = () => [
  w.editorAttributes.of({
    class: "ink-mde-editor"
  }),
  w.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
], rn = () => [
  ...on()
], an = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: n }) => e.selection.ranges.some((t) => !t.empty) ? mt({ state: e, dispatch: n }) : (n(e.update(e.replaceSelection("  "), {
      scrollIntoView: !0,
      annotations: lt.userEvent.of("input")
    })), !0),
    shift: ht
  }
], ln = () => dt.of([
  ...an,
  ...gt,
  ...pt
]), sn = () => w.lineWrapping, cn = () => [
  ut(ft.define([
    {
      tag: d.atom,
      color: "var(--ink-internal-syntax-atom-color)"
    },
    {
      tag: d.meta,
      color: "var(--ink-internal-syntax-meta-color)"
    },
    {
      tag: d.emphasis,
      color: "var(--ink-internal-syntax-emphasis-color)",
      fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
    },
    {
      tag: d.strong,
      color: "var(--ink-internal-syntax-strong-color)",
      fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
    },
    {
      tag: d.strikethrough,
      color: "var(--ink-internal-syntax-strikethrough-color)",
      textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
    },
    {
      tag: d.comment,
      color: "var(--ink-internal-syntax-comment-color)",
      fontStyle: "var(--ink-internal-syntax-comment-font-style)"
    },
    {
      tag: d.monospace,
      color: "var(--ink-internal-syntax-code-color)",
      fontFamily: "var(--ink-internal-syntax-code-font-family)"
    },
    {
      tag: d.name,
      color: "var(--ink-internal-syntax-name-color)"
    },
    {
      tag: d.labelName,
      color: "var(--ink-internal-syntax-name-label-color)"
    },
    {
      tag: d.propertyName,
      color: "var(--ink-internal-syntax-name-property-color)"
    },
    {
      tag: d.definition(d.propertyName),
      color: "var(--ink-internal-syntax-name-property-definition-color)"
    },
    {
      tag: d.variableName,
      color: "var(--ink-internal-syntax-name-variable-color)"
    },
    {
      tag: d.definition(d.variableName),
      color: "var(--ink-internal-syntax-name-variable-definition-color)"
    },
    {
      tag: d.local(d.variableName),
      color: "var(--ink-internal-syntax-name-variable-local-color)"
    },
    {
      tag: d.special(d.variableName),
      color: "var(--ink-internal-syntax-name-variable-special-color)"
    },
    {
      tag: d.heading,
      color: "var(--ink-internal-syntax-heading-color)",
      fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
    },
    {
      tag: d.heading1,
      color: "var(--ink-internal-syntax-heading1-color)",
      fontSize: "var(--ink-internal-syntax-heading1-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
    },
    {
      tag: d.heading2,
      color: "var(--ink-internal-syntax-heading2-color)",
      fontSize: "var(--ink-internal-syntax-heading2-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
    },
    {
      tag: d.heading3,
      color: "var(--ink-internal-syntax-heading3-color)",
      fontSize: "var(--ink-internal-syntax-heading3-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
    },
    {
      tag: d.heading4,
      color: "var(--ink-internal-syntax-heading4-color)",
      fontSize: "var(--ink-internal-syntax-heading4-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
    },
    {
      tag: d.heading5,
      color: "var(--ink-internal-syntax-heading5-color)",
      fontSize: "var(--ink-internal-syntax-heading5-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
    },
    {
      tag: d.heading6,
      color: "var(--ink-internal-syntax-heading6-color)",
      fontSize: "var(--ink-internal-syntax-heading6-font-size)",
      fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
    },
    {
      tag: d.keyword,
      color: "var(--ink-internal-syntax-keyword-color)"
    },
    {
      tag: d.number,
      color: "var(--ink-internal-syntax-number-color)"
    },
    {
      tag: d.operator,
      color: "var(--ink-internal-syntax-operator-color)"
    },
    {
      tag: d.punctuation,
      color: "var(--ink-internal-syntax-punctuation-color)"
    },
    {
      tag: d.link,
      color: "var(--ink-internal-syntax-link-color)"
    },
    {
      tag: d.url,
      color: "var(--ink-internal-syntax-url-color)"
    },
    {
      tag: d.string,
      color: "var(--ink-internal-syntax-string-color)"
    },
    {
      tag: d.special(d.string),
      color: "var(--ink-internal-syntax-string-special-color)"
    },
    {
      tag: d.processingInstruction,
      color: "var(--ink-internal-syntax-processing-instruction-color)"
    }
  ]))
], dn = (e) => {
  if (e.length > 0)
    return Ae(e);
}, Be = (e) => {
  const n = e.options.plugins.flatMap((r) => r.type === Y.Completion ? r.value : []), t = e.options.plugins.flatMap((r) => r.type === Y.Default ? r.value : []), o = e.options.plugins.flatMap((r) => r.type === Y.Grammar ? r.value : []);
  return le.create({
    doc: e.options.doc,
    selection: dn(e.options.selections),
    extensions: [
      ...Ht(e),
      nt({
        defaultKeymap: !0,
        icons: !1,
        override: n,
        optionClass: () => "ink-tooltip-option"
      }),
      nn(),
      kt(),
      rn(),
      ln(),
      sn(),
      xt({
        base: bt,
        codeLanguages: vt,
        extensions: o
      }),
      cn(),
      ...t
    ]
  });
}, un = ([e, n]) => {
  const { editor: t } = e();
  t.destroy();
}, fn = ([e, n]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, ce = ([e, n]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, gn = ([e, n], t, o) => qt([e, n], t, o), N = ([e, n], t, o, r = !1) => {
  const { editor: i } = e();
  let a = o?.start, l = o?.end || o?.start;
  if (typeof a > "u") {
    const c = ee([e, n]).pop();
    a = c.start, l = c.end;
  }
  const s = { changes: { from: a, to: l, insert: t } };
  if (r) {
    const c = a === l ? a + t.length : a, b = a + t.length;
    Object.assign(s, { selection: { anchor: c, head: b } });
  }
  i.dispatch(i.state.update(s));
}, pn = ([e, n], t) => {
  n(F(e(), { options: { doc: t } })), e().editor.setState(Be(e()));
}, mn = (e) => ({
  destroy: un.bind(void 0, e),
  doc: fn.bind(void 0, e),
  focus: ce.bind(void 0, e),
  insert: N.bind(void 0, e),
  load: pn.bind(void 0, e),
  options: hn.bind(void 0, e),
  reconfigure: kn.bind(void 0, e),
  select: Ee.bind(void 0, e),
  selections: ee.bind(void 0, e),
  update: xn.bind(void 0, e),
  wrap: te.bind(void 0, e)
}), hn = ([e]) => e().options, kn = ([e, n], t) => {
  const o = Se(n(F(e(), { options: t })));
  e().editor.dispatch({
    effects: o
  });
}, Ee = ([e, n], t) => {
  const { editor: o } = e();
  o.dispatch(o.state.update({
    selection: Ae(t)
  }));
}, ee = ([e, n]) => {
  const { editor: t } = e();
  return Tt(t.state.selection);
}, xn = ([e, n], t) => {
  const { editor: o } = e();
  o.dispatch(o.state.update({
    changes: {
      from: 0,
      to: o.state.doc.length,
      insert: t
    }
  }));
}, te = ([e, n], { after: t, before: o, selection: r }) => {
  const { editor: i } = e(), a = r || ee([e, n]).pop() || { start: 0, end: 0 }, l = i.state.sliceDoc(a.start, a.end);
  N([e, n], `${o}${l}${t}`, a), Ee([e, n], [{ start: a.start + o.length, end: a.end + o.length }]);
}, bn = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, vn = /* @__PURE__ */ m("<span>uploading files...</span>", 2), yn = /* @__PURE__ */ m('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), $n = /* @__PURE__ */ m('<img class="ink-drop-zone-file-preview-image">', 1), wn = /* @__PURE__ */ m("<span>drop files here</span>", 2), _n = () => {
  const [e, n] = B(0), [t, o] = B([]), [r, i] = B(!1), [a, l] = B(!1), [s, c] = R(), b = () => {
    l(!1);
  }, y = (f) => {
    if (s().options.files.dragAndDrop) {
      f.preventDefault(), f.stopPropagation();
      const h = f.dataTransfer;
      h?.files ? U(h.files) : (n(0), l(!1), o([]));
    }
  }, S = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), n(e() + 1), l(!0));
  }, E = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), n(e() - 1), e() === 0 && l(!1));
  }, A = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), l(!0));
  }, j = (f) => {
    s().options.files.dragAndDrop && (f.preventDefault(), n(0), l(!1));
  }, P = (f) => {
    if (s().options.files.clipboard) {
      f.preventDefault();
      const h = f.clipboardData;
      h?.files && h.files.length > 0 && U(h.files);
    }
  }, U = (f) => {
    Array.from(f).forEach((h) => {
      o([...t(), h]);
    }), i(!0), l(!0), Promise.resolve(s().options.files.handler(f)).then((h) => {
      if (s().options.files.injectMarkup && h) {
        const O = `![](${h})`;
        N([s, c], O);
      }
    }).finally(() => {
      n(0), i(!1), l(!1), o([]);
    });
  };
  return _e(() => {
    document.addEventListener("dragenter", S), document.addEventListener("dragleave", E), document.addEventListener("dragover", A), document.addEventListener("drop", j), s().root.addEventListener("paste", P);
  }), Ze(() => {
    document.removeEventListener("dragenter", S), document.removeEventListener("dragleave", E), document.removeEventListener("dragover", A), document.removeEventListener("drop", j), s().root.removeEventListener("paste", P);
  }), (() => {
    const f = p(yn), h = f.firstChild, O = h.nextSibling, D = O.firstChild, q = D.firstChild, ne = q.nextSibling, [X, oe] = x(ne.nextSibling), re = D.nextSibling;
    return h.textContent = bn, D.addEventListener("drop", y), k(q, u(Ge, {
      get each() {
        return t().slice(0, 8);
      },
      children: (Q) => (() => {
        const I = p($n);
        return ae((_) => {
          const K = Q.name, W = URL.createObjectURL(Q);
          return K !== _._v$ && ke(I, "alt", _._v$ = K), W !== _._v$2 && ke(I, "src", _._v$2 = W), _;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), I;
      })()
    })), k(D, u(v, {
      get when() {
        return r();
      },
      get fallback() {
        return p(wn);
      },
      get children() {
        return p(vn);
      }
    }), X, oe), re.$$click = b, ae(() => f.classList.toggle("visible", !!a())), we(), f;
  })();
};
$e(["click"]);
const Cn = (e) => {
  const n = new w({
    dispatch: (t) => {
      const { options: o } = e;
      o.hooks.beforeUpdate(t.newDoc.toString()), n.update([t]), t.docChanged && o.hooks.afterUpdate(t.newDoc.toString());
    },
    state: Be(e)
  });
  return n;
}, Ln = () => {
  const [e, n] = R(), t = Cn(e());
  return n(F(e(), {
    editor: t
  })), t.dom;
}, Sn = /* @__PURE__ */ m('<button class="ink-button"></button>', 2), $ = (e) => (() => {
  const n = p(Sn);
  return n.$$click = (t) => e.onclick(t), k(n, () => e.children), we(), n;
})();
$e(["click"]);
const Mn = `.ink .ink-toolbar{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);bottom:.25rem;color:inherit;display:flex;flex-shrink:0;gap:2rem;overflow:auto;padding:.25rem;position:sticky;top:.25rem;z-index:10}.ink .ink-toolbar-group{display:flex}.ink .ink-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink .ink-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink .ink-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, An = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), Dn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), zn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), Hn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), Bn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), En = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), jn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), Vn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Tn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), Nn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), On = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), In = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), Wn = /* @__PURE__ */ m('<input type="file">', 1), Fn = /* @__PURE__ */ m('<div class="ink-toolbar"><style></style><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-toolbar-group"><!#><!/><!#><!/><!#><!/></div></div>', 36), Rn = () => {
  const [e, n] = R(), [t, o] = B(), r = (l) => {
    gn([e, n], l), ce([e, n]);
  }, i = (l) => {
    const s = l.target;
    s?.files && Promise.resolve(e().options.files.handler(s.files)).then((c) => {
      const b = `![](${c})`;
      N([e, n], b), ce([e, n]);
    });
  }, a = () => {
    t()?.click();
  };
  return (() => {
    const l = p(Fn), s = l.firstChild, c = s.nextSibling, b = c.firstChild, [y, S] = x(b.nextSibling), E = y.nextSibling, [A, j] = x(E.nextSibling), P = A.nextSibling, [U, f] = x(P.nextSibling), h = c.nextSibling, O = h.firstChild, [D, q] = x(O.nextSibling), ne = D.nextSibling, [X, oe] = x(ne.nextSibling), re = X.nextSibling, [Q, I] = x(re.nextSibling), _ = h.nextSibling, K = _.firstChild, [W, Ve] = x(K.nextSibling), Te = W.nextSibling, [pe, Ne] = x(Te.nextSibling), Oe = pe.nextSibling, [Ie, We] = x(Oe.nextSibling), Z = _.nextSibling, Fe = Z.firstChild, [me, Re] = x(Fe.nextSibling), Pe = me.nextSibling, [he, Ue] = x(Pe.nextSibling), qe = he.nextSibling, [Xe, Qe] = x(qe.nextSibling);
    return s.textContent = Mn, k(c, u(v, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Heading),
          get children() {
            return p(An);
          }
        });
      }
    }), y, S), k(c, u(v, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Bold),
          get children() {
            return p(Dn);
          }
        });
      }
    }), A, j), k(c, u(v, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Italic),
          get children() {
            return p(zn);
          }
        });
      }
    }), U, f), k(h, u(v, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Quote),
          get children() {
            return p(Hn);
          }
        });
      }
    }), D, q), k(h, u(v, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return u($, {
          onclick: () => r(g.CodeBlock),
          get children() {
            return p(Bn);
          }
        });
      }
    }), X, oe), k(h, u(v, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Code),
          get children() {
            return p(En);
          }
        });
      }
    }), Q, I), k(_, u(v, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return u($, {
          onclick: () => r(g.List),
          get children() {
            return p(jn);
          }
        });
      }
    }), W, Ve), k(_, u(v, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return u($, {
          onclick: () => r(g.OrderedList),
          get children() {
            return p(Vn);
          }
        });
      }
    }), pe, Ne), k(_, u(v, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return u($, {
          onclick: () => r(g.TaskList),
          get children() {
            return p(Tn);
          }
        });
      }
    }), Ie, We), k(Z, u(v, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Link),
          get children() {
            return p(Nn);
          }
        });
      }
    }), me, Re), k(Z, u(v, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return u($, {
          onclick: () => r(g.Image),
          get children() {
            return p(On);
          }
        });
      }
    }), he, Ue), k(Z, u(v, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return u($, {
          onclick: a,
          get children() {
            return [p(In), (() => {
              const G = p(Wn);
              return o(G), G.addEventListener("change", i), G.style.setProperty("display", "none"), G;
            })()];
          }
        });
      }
    }), Xe, Qe), l;
  })();
}, Pn = `.ink{color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column);gap:1rem;padding:var(--ink-internal-editor-padding, 0)}.ink .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, Un = /* @__PURE__ */ m("<style> </style>", 2), qn = () => {
  const [e] = R(), [n, t] = B(ie(e()));
  return Ye(() => {
    t(ie(e()));
  }), _e(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), r = (i) => {
      const {
        editor: a,
        root: l
      } = e();
      if (l.isConnected) {
        const s = Se(e());
        a.dispatch({
          effects: s
        }), t(ie(e()));
      } else
        o.removeEventListener("change", r);
    };
    o.addEventListener("change", r);
  }), (() => {
    const o = p(Un), r = o.firstChild;
    return ae(() => r.data = `.ink {
  ${n().join(`
  `)}
}
${Pn}`), o;
  })();
}, Xn = /* @__PURE__ */ m('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><!#><!/></div>', 10), Qn = () => {
  const [e, n] = R(), t = (o) => {
    n(F(e(), {
      root: o
    }));
  };
  return (() => {
    const o = p(Xn), r = o.firstChild, [i, a] = x(r.nextSibling), l = i.nextSibling, [s, c] = x(l.nextSibling), b = s.nextSibling, [y, S] = x(b.nextSibling), E = y.nextSibling, [A, j] = x(E.nextSibling);
    return t(o), k(o, u(qn, {}), i, a), k(o, u(_n, {}), s, c), k(o, u(v, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return u(Rn, {});
      }
    }), y, S), k(o, u(Ln, {}), A, j), o;
  })();
}, je = Je([() => se(), (e) => typeof e == "function" ? e(se()) : e]), Kn = (e) => u(je.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), R = () => et(je), Zn = (e) => u(Kn, {
  get store() {
    return e.store;
  },
  get children() {
    return u(Qn, {
      get store() {
        return e.store;
      }
    });
  }
}), co = ({ theme: e, decorator: n }) => {
  const t = w.baseTheme(e), o = (a) => L.widget({
    widget: a,
    side: -1,
    block: !0
  }), r = (a) => {
    const s = n(a).map((c) => o(c.widget).range(c.from, c.to));
    return s.length > 0 ? J.of(s) : L.none;
  }, i = de.define({
    create(a) {
      return r(a);
    },
    update(a, l) {
      return l.docChanged ? r(l.state) : a.map(l.changes);
    },
    provide(a) {
      return w.decorations.from(a);
    }
  });
  return [
    t,
    i
  ];
}, uo = (e = {}) => (Me(e), ""), fo = (e) => e, go = (e, n = {}) => {
  const t = Me(n);
  return Gn(), Ke(() => u(Zn, {
    store: t
  }), e), mn(t);
}, Gn = () => {
  let e, n;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), n = (t) => t && t.hasAttribute && (t.hasAttribute("data-hk") ? t : n(t.host && t.host instanceof Node ? t.host : t.parentNode)), ["click", "input"].forEach((t) => document.addEventListener(t, (o) => {
    let r = o.composedPath && o.composedPath()[0] || o.target, i = n(r);
    i && !e.completed.has(i) && e.events.push([i, o]);
  })), e.init = (t, o) => {
    e.r[t] = [new Promise((r, i) => o = r), o];
  }, e.set = (t, o, r) => {
    (r = e.r[t]) && r[1](o), e.r[t] = [o];
  }, e.unset = (t) => {
    delete e.r[t];
  }, e.load = (t, o) => {
    if (o = e.r[t])
      return o[0];
  };
};
export {
  T as Appearance,
  M as Extensions,
  g as Markup,
  Y as PluginType,
  go as default,
  fo as defineOptions,
  co as extension,
  go as ink,
  Gn as prepareHydration,
  uo as ssr
};
